/*
 * FastaCheckerThread.java
 *
 * Created on Oct 19, 2007, 5:45:24 PM
 *
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package nl.uu.chem.bioinformatics.statquant.fastachecker;

import java.util.HashMap;
import nl.uu.chem.bioinformatics.statquant.model.FastaCheckerThreadOperation;
import nl.uu.chem.bioinformatics.statquant.model.FastaSequence;

/**
 *
 * @author Toorn101
 */
public class FastaCheckerThread extends Thread {

    private final FastaCheckerThreadPool pool;
    private HashMap<String, Void> map;
    private int number;

    public FastaCheckerThread(FastaCheckerThreadPool pool, HashMap<String, Void> map, int number) {
        super("FastaCheckerThread_"+number);
        this.pool = pool;
        this.map = map;
        this.number = number;
    }

    @Override
    public void run() {
        /* Use the Java hash search to map the parts of the
        fasta sequence strings on the existing map */
        FastaCheckerThreadOperation assignment;
        
        while ((assignment = pool.getNewAssignment()) != null) {
            
            FastaSequence fastaseq = assignment.getSeq();
            String seq = fastaseq.getSequence();
            for (int position = 0; position <= seq.length() - assignment.getLength(); position++) {
                String subsequence = seq.substring(position, position + assignment.getLength());
                if (map.containsKey(subsequence)) {
                    pool.updatePeptide(subsequence, fastaseq.getIdentifier());
                }
            }
            yield();
        }
        pool.doneWorking();
    }
}