/*
 * SplashScreen.java
 *
 * Created on October 9, 2007, 4:21 PM
 */

package nl.uu.chem.bioinformatics.statquant.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;

/**
 *
 * @author  Toorn101
 */
public class SplashScreen extends JFrame {

    public SplashScreen() {
        init(false);

    }
    /** Creates new form SplashScreen */
    public SplashScreen(boolean asAboutBox) {
        init(asAboutBox);
    }

    private void init (boolean asAboutBox) {
        try {
            initComponents();
            aboutBoxPanel.setVisible(asAboutBox);
            Properties appinfo = new Properties();
            appinfo.load(this.getClass().getResourceAsStream("/application.properties"));
            copyrightText.setText(appinfo.getProperty("copyright.text"));
            versionText.setText(appinfo.getProperty("version"));
            versionText.setForeground(Color.WHITE);
            
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            int x = Math.max(screenSize.width / 2 - this.getSize().width / 2, 0);
            int y = Math.max(screenSize.height / 2 - this.getSize().height / 2, 0);
            this.setLocation(x, y);

            JLabel splashImage = new JLabel();

            splashImage.setIcon(new ImageIcon(this.getClass().getResource("/splash.jpg")));
            imagePanel.add(splashImage);

            final SplashScreen parent = this;
            imagePanel.addMouseListener(new MouseListener() {

                @Override
                public void mouseClicked(MouseEvent e) {
                    parent.setVisible(false);
                }

                @Override
                public void mousePressed(MouseEvent e) {
                }

                @Override
                public void mouseReleased(MouseEvent e) {
                }

                @Override
                public void mouseEntered(MouseEvent e) {
                }

                @Override
                public void mouseExited(MouseEvent e) {
                }
            });



            if (!asAboutBox) startRemovalTimer();
        } catch (IOException ex) {
            Logger.getLogger(SplashScreen.class.getName()).log(Level.SEVERE, null, ex);
        }
    }


    private void startRemovalTimer() {
        final JFrame frame = this;

        new Thread() {

            @Override
            public void run() {
                try {
                    sleep(5000);
                    frame.setVisible(false);
                } catch (InterruptedException ex) {
                    Logger.getLogger(SplashScreen.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }.start();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        licenseDialog = new javax.swing.JDialog();
        jScrollPane1 = new javax.swing.JScrollPane();
        licenseTextField = new javax.swing.JTextArea();
        closeButton = new javax.swing.JButton();
        jLayeredPane1 = new javax.swing.JLayeredPane();
        aboutBoxPanel = new javax.swing.JPanel();
        licenseButton = new javax.swing.JButton();
        versionPanel = new javax.swing.JPanel();
        versionText = new javax.swing.JLabel();
        copyrightPanel = new javax.swing.JPanel();
        copyrightText = new javax.swing.JTextPane();
        imagePanel = new javax.swing.JPanel();

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(nl.uu.chem.bioinformatics.statquant.gui.StatQuantGui.class).getContext().getResourceMap(SplashScreen.class);
        licenseDialog.setTitle(resourceMap.getString("licenseDialog.title")); // NOI18N
        licenseDialog.setAlwaysOnTop(true);
        licenseDialog.setLocationByPlatform(true);
        licenseDialog.setMinimumSize(new java.awt.Dimension(800, 600));
        licenseDialog.setName("licenseDialog"); // NOI18N
        licenseDialog.setResizable(false);

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        licenseTextField.setColumns(20);
        licenseTextField.setEditable(false);
        licenseTextField.setRows(5);
        licenseTextField.setName("licenseTextField"); // NOI18N
        jScrollPane1.setViewportView(licenseTextField);

        closeButton.setText("close"); // NOI18N
        closeButton.setName("closeButton"); // NOI18N
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout licenseDialogLayout = new javax.swing.GroupLayout(licenseDialog.getContentPane());
        licenseDialog.getContentPane().setLayout(licenseDialogLayout);
        licenseDialogLayout.setHorizontalGroup(
            licenseDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, licenseDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(licenseDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 650, Short.MAX_VALUE)
                    .addComponent(closeButton))
                .addContainerGap())
        );
        licenseDialogLayout.setVerticalGroup(
            licenseDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, licenseDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 446, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(closeButton)
                .addContainerGap())
        );

        setAlwaysOnTop(true);
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setMinimumSize(new java.awt.Dimension(350, 500));
        setName("splashscreen"); // NOI18N
        setResizable(false);
        setUndecorated(true);

        jLayeredPane1.setBackground(resourceMap.getColor("jLayeredPane1.background")); // NOI18N
        jLayeredPane1.setMaximumSize(new java.awt.Dimension(350, 500));
        jLayeredPane1.setMinimumSize(new java.awt.Dimension(350, 500));
        jLayeredPane1.setName("jLayeredPane1"); // NOI18N

        aboutBoxPanel.setName("aboutBoxPanel"); // NOI18N
        aboutBoxPanel.setOpaque(false);

        licenseButton.setText("license"); // NOI18N
        licenseButton.setName("licenseButton"); // NOI18N
        licenseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                licenceButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout aboutBoxPanelLayout = new javax.swing.GroupLayout(aboutBoxPanel);
        aboutBoxPanel.setLayout(aboutBoxPanelLayout);
        aboutBoxPanelLayout.setHorizontalGroup(
            aboutBoxPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(aboutBoxPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(licenseButton)
                .addContainerGap(275, Short.MAX_VALUE))
        );
        aboutBoxPanelLayout.setVerticalGroup(
            aboutBoxPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(aboutBoxPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(licenseButton)
                .addContainerGap(466, Short.MAX_VALUE))
        );

        aboutBoxPanel.setBounds(0, 0, 350, 500);
        jLayeredPane1.add(aboutBoxPanel, javax.swing.JLayeredPane.DEFAULT_LAYER);

        versionPanel.setBackground(resourceMap.getColor("versionPanel.background")); // NOI18N
        versionPanel.setName("versionPanel"); // NOI18N
        versionPanel.setOpaque(false);

        versionText.setFont(new java.awt.Font("Tahoma", 1, 10));
        versionText.setForeground(resourceMap.getColor("versionText.foreground")); // NOI18N
        versionText.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        versionText.setText(resourceMap.getString("versionText.text")); // NOI18N
        versionText.setName("versionText"); // NOI18N

        javax.swing.GroupLayout versionPanelLayout = new javax.swing.GroupLayout(versionPanel);
        versionPanel.setLayout(versionPanelLayout);
        versionPanelLayout.setHorizontalGroup(
            versionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(versionPanelLayout.createSequentialGroup()
                .addGap(241, 241, 241)
                .addComponent(versionText, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
                .addContainerGap())
        );
        versionPanelLayout.setVerticalGroup(
            versionPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(versionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(versionText, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(466, Short.MAX_VALUE))
        );

        versionPanel.setBounds(0, 0, 350, 500);
        jLayeredPane1.add(versionPanel, javax.swing.JLayeredPane.DEFAULT_LAYER);

        copyrightPanel.setBackground(resourceMap.getColor("copyrightPanel.background")); // NOI18N
        copyrightPanel.setName("copyrightPanel"); // NOI18N
        copyrightPanel.setOpaque(false);

        copyrightText.setBorder(null);
        copyrightText.setContentType("text/html"); // NOI18N
        copyrightText.setEditable(false);
        copyrightText.setForeground(new java.awt.Color(255, 255, 255));
        copyrightText.setText("<html> <head></head><body><p style=\"margin-top: 0\"></p><h1>Copyright</h1></body></html>"); // NOI18N
        copyrightText.setAutoscrolls(false);
        copyrightText.setName("copyrightText"); // NOI18N
        copyrightText.setOpaque(false);

        javax.swing.GroupLayout copyrightPanelLayout = new javax.swing.GroupLayout(copyrightPanel);
        copyrightPanel.setLayout(copyrightPanelLayout);
        copyrightPanelLayout.setHorizontalGroup(
            copyrightPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 330, Short.MAX_VALUE)
            .addGroup(copyrightPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(copyrightPanelLayout.createSequentialGroup()
                    .addGap(0, 0, Short.MAX_VALUE)
                    .addComponent(copyrightText, javax.swing.GroupLayout.PREFERRED_SIZE, 330, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, Short.MAX_VALUE)))
        );
        copyrightPanelLayout.setVerticalGroup(
            copyrightPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 80, Short.MAX_VALUE)
            .addGroup(copyrightPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(copyrightPanelLayout.createSequentialGroup()
                    .addGap(0, 0, Short.MAX_VALUE)
                    .addComponent(copyrightText, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(0, 0, Short.MAX_VALUE)))
        );

        copyrightPanel.setBounds(10, 420, 330, 70);
        jLayeredPane1.add(copyrightPanel, javax.swing.JLayeredPane.DEFAULT_LAYER);

        imagePanel.setBackground(resourceMap.getColor("imagePanel.background")); // NOI18N
        imagePanel.setName("imagePanel"); // NOI18N
        imagePanel.setLayout(new java.awt.GridBagLayout());
        imagePanel.setBounds(0, 0, 350, 500);
        jLayeredPane1.add(imagePanel, javax.swing.JLayeredPane.DEFAULT_LAYER);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLayeredPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 350, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLayeredPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 500, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void licenceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_licenceButtonActionPerformed
        BufferedReader licenseTextStream = new BufferedReader(new InputStreamReader(this.getClass().getResourceAsStream("/LICENSE.txt")));
        StringBuilder licenseStringBuilder = new StringBuilder();
        String line;
        try {
            while ((line = licenseTextStream.readLine()) != null) {
                licenseStringBuilder.append(line);
                licenseStringBuilder.append("\n");
            }
        } catch (IOException ex) {
            Logger.getLogger(SplashScreen.class.getName()).log(Level.SEVERE, null, ex);
        }

        licenseTextField.setText(licenseStringBuilder.toString());
        licenseTextField.setCaretPosition(0);
        licenseDialog.setVisible(true);
}//GEN-LAST:event_licenceButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
    licenseDialog.setVisible(false);
}//GEN-LAST:event_closeButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel aboutBoxPanel;
    private javax.swing.JButton closeButton;
    private javax.swing.JPanel copyrightPanel;
    private javax.swing.JTextPane copyrightText;
    private javax.swing.JPanel imagePanel;
    private javax.swing.JLayeredPane jLayeredPane1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton licenseButton;
    private javax.swing.JDialog licenseDialog;
    private javax.swing.JTextArea licenseTextField;
    private javax.swing.JPanel versionPanel;
    private javax.swing.JLabel versionText;
    // End of variables declaration//GEN-END:variables
}